Subject: Re: bug#78898: Make read/readevalloop reentrant

From: Mattias Engdegård <[email-masked]>
Date: Sat, 5 Jul 2025 12:13:07 +0200

28 juni 2025 kl. 12.08 skrev Eli Zaretskii <[email-masked]>:

> Do we really want readevalloop be recursive this way?  What does this
> gain us?

In principle there should be no reason for readevalloop being non-reentrant at all and remedying this should be an obvious improvement, but I cannot give a concrete example of how it would benefit us immediately.

That said, I think the approach here is a bit too much at once; I'd rather nibble away at state a little at a time since much of lread.c is messy legacy code.

More to the point, I have a patch for lread.c which cleans up some poor code, fixes some bugs and most importantly improves reader performance. I'd rather that go in first, as it provides tangible improvements and so that I won't have to undo Lynn's changes when applying it. (Further work in bug#70988).